/**
 */
package org.etsi.mts.tdl.impl;

import java.lang.reflect.InvocationTargetException;

import java.util.Collection;

import java.util.Iterator;
import java.util.List;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.ocl.pivot.evaluation.Executor;
import org.eclipse.ocl.pivot.ids.IdResolver;
import org.eclipse.ocl.pivot.ids.IdResolver.IdResolverExtension;
import org.eclipse.ocl.pivot.library.collection.CollectionAsOrderedSetOperation;
import org.eclipse.ocl.pivot.library.collection.CollectionIsEmptyOperation;
import org.eclipse.ocl.pivot.library.oclany.OclAnyOclAsSetOperation;
import org.eclipse.ocl.pivot.messages.PivotMessages;
import org.eclipse.ocl.pivot.utilities.PivotUtil;
import org.eclipse.ocl.pivot.utilities.ValueUtil;
import org.eclipse.ocl.pivot.values.BagValue;
import org.eclipse.ocl.pivot.values.BagValue.Accumulator;
import org.eclipse.ocl.pivot.values.InvalidValueException;
import org.eclipse.ocl.pivot.values.OrderedSetValue;
import org.eclipse.ocl.pivot.values.SetValue;
import org.etsi.mts.tdl.AtomicBehaviour;
import org.etsi.mts.tdl.Behaviour;
import org.etsi.mts.tdl.ComponentInstance;
import org.etsi.mts.tdl.ComponentInstanceBinding;
import org.etsi.mts.tdl.ParameterBinding;
import org.etsi.mts.tdl.TestConfiguration;
import org.etsi.mts.tdl.TestDescription;
import org.etsi.mts.tdl.TestDescriptionReference;
import org.etsi.mts.tdl.tdlPackage;
import org.etsi.mts.tdl.tdlTables;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Test Description Reference</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link org.etsi.mts.tdl.impl.TestDescriptionReferenceImpl#getTestDescription <em>Test Description</em>}</li>
 *   <li>{@link org.etsi.mts.tdl.impl.TestDescriptionReferenceImpl#getComponentInstanceBinding <em>Component Instance Binding</em>}</li>
 *   <li>{@link org.etsi.mts.tdl.impl.TestDescriptionReferenceImpl#getArgument <em>Argument</em>}</li>
 * </ul>
 *
 * @generated
 */
public class TestDescriptionReferenceImpl extends AtomicBehaviourImpl implements TestDescriptionReference
{
	/**
	 * The cached value of the '{@link #getTestDescription() <em>Test Description</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTestDescription()
	 * @generated
	 * @ordered
	 */
	protected TestDescription testDescription;

	/**
	 * The cached value of the '{@link #getComponentInstanceBinding() <em>Component Instance Binding</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getComponentInstanceBinding()
	 * @generated
	 * @ordered
	 */
	protected EList<ComponentInstanceBinding> componentInstanceBinding;

	/**
	 * The cached value of the '{@link #getArgument() <em>Argument</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getArgument()
	 * @generated
	 * @ordered
	 */
	protected EList<ParameterBinding> argument;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TestDescriptionReferenceImpl()
	{
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass()
	{
		return tdlPackage.Literals.TEST_DESCRIPTION_REFERENCE;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public TestDescription getTestDescription()
	{
		if (testDescription != null && testDescription.eIsProxy()) {
			InternalEObject oldTestDescription = (InternalEObject)testDescription;
			testDescription = (TestDescription)eResolveProxy(oldTestDescription);
			if (testDescription != oldTestDescription) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION, oldTestDescription, testDescription));
			}
		}
		return testDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TestDescription basicGetTestDescription()
	{
		return testDescription;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void setTestDescription(TestDescription newTestDescription)
	{
		TestDescription oldTestDescription = testDescription;
		testDescription = newTestDescription;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION, oldTestDescription, testDescription));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ComponentInstanceBinding> getComponentInstanceBinding()
	{
		if (componentInstanceBinding == null) {
			componentInstanceBinding = new EObjectContainmentEList<ComponentInstanceBinding>(ComponentInstanceBinding.class, this, tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING);
		}
		return componentInstanceBinding;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EList<ParameterBinding> getArgument()
	{
		if (argument == null) {
			argument = new EObjectContainmentEList<ParameterBinding>(ParameterBinding.class, this, tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT);
		}
		return argument;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public EList<ComponentInstance> getParticipatingComponents()
	{
		/**
		 *
		 * if
		 *   self.getParentTestDescription()
		 *   ->exists(td | td.isLocallyOrdered) and
		 *   not self.componentInstanceBinding->isEmpty()
		 * then self.componentInstanceBinding.actualComponent->asOrderedSet()
		 * else
		 *   self.getParentTestDescription()
		 *   .testConfiguration.componentInstance->asOrderedSet()
		 * endif
		 */
		final /*@NonInvalid*/ Executor executor = PivotUtil.getExecutor(this);
		final /*@NonInvalid*/ IdResolver idResolver = executor.getIdResolver();
		final /*@NonInvalid*/ List<ComponentInstanceBinding> componentInstanceBinding_0 = this.getComponentInstanceBinding();
		final /*@NonInvalid*/ TestDescription getParentTestDescription_0 = this.getParentTestDescription();
		final /*@NonInvalid*/ SetValue BOXED_componentInstanceBinding_0 = idResolver.createSetOfAll(tdlTables.SET_CLSSid_ComponentInstanceBinding, componentInstanceBinding_0);
		final /*@NonInvalid*/ SetValue oclAsSet = OclAnyOclAsSetOperation.INSTANCE.evaluate(executor, tdlTables.SET_CLSSid_TestDescription, getParentTestDescription_0);
		/*@Thrown*/ Object accumulator = ValueUtil.FALSE_VALUE;
		Iterator<Object> ITERATOR_td = oclAsSet.iterator();
		/*@NonInvalid*/ Boolean exists;
		while (true) {
			if (!ITERATOR_td.hasNext()) {
				if (accumulator == ValueUtil.FALSE_VALUE) {
					exists = ValueUtil.FALSE_VALUE;
				}
				else {
					throw (InvalidValueException)accumulator;
				}
				break;
			}
			/*@NonInvalid*/ TestDescription td = (TestDescription)ITERATOR_td.next();
			/**
			 * td.isLocallyOrdered
			 */
			final /*@NonInvalid*/ boolean isLocallyOrdered = td.isIsLocallyOrdered();
			//
			if (isLocallyOrdered) {					// Normal successful body evaluation result
				exists = ValueUtil.TRUE_VALUE;
				break;														// Stop immediately
			}
			else if (!isLocallyOrdered) {				// Normal unsuccessful body evaluation result
				;															// Carry on
			}
			else {															// Impossible badly typed result
				accumulator = new InvalidValueException(PivotMessages.NonBooleanBody, "exists");
			}
		}
		final /*@Thrown*/ Boolean and;
		if (exists == ValueUtil.FALSE_VALUE) {
			and = ValueUtil.FALSE_VALUE;
		}
		else {
			final /*@NonInvalid*/ boolean isEmpty = CollectionIsEmptyOperation.INSTANCE.evaluate(BOXED_componentInstanceBinding_0).booleanValue();
			final /*@NonInvalid*/ Boolean not;
			if (!isEmpty) {
				not = ValueUtil.TRUE_VALUE;
			}
			else {
				if (isEmpty) {
					not = ValueUtil.FALSE_VALUE;
				}
				else {
					not = null;
				}
			}
			if (not == ValueUtil.FALSE_VALUE) {
				and = ValueUtil.FALSE_VALUE;
			}
			else {
				if ((exists == null) || (not == null)) {
					and = null;
				}
				else {
					and = ValueUtil.TRUE_VALUE;
				}
			}
		}
		if (and == null) {
			throw new InvalidValueException("Null if condition");
		}
		/*@NonInvalid*/ OrderedSetValue local_0;
		if (and) {
			/*@Thrown*/ Accumulator accumulator_0 = ValueUtil.createBagAccumulatorValue(tdlTables.BAG_CLSSid_ComponentInstance);
			Iterator<Object> ITERATOR__1 = BOXED_componentInstanceBinding_0.iterator();
			/*@NonInvalid*/ BagValue collect;
			while (true) {
				if (!ITERATOR__1.hasNext()) {
					collect = accumulator_0;
					break;
				}
				/*@NonInvalid*/ ComponentInstanceBinding _1 = (ComponentInstanceBinding)ITERATOR__1.next();
				/**
				 * actualComponent
				 */
				final /*@NonInvalid*/ ComponentInstance actualComponent = _1.getActualComponent();
				//
				accumulator_0.add(actualComponent);
			}
			final /*@NonInvalid*/ OrderedSetValue asOrderedSet = CollectionAsOrderedSetOperation.INSTANCE.evaluate(collect);
			local_0 = asOrderedSet;
		}
		else {
			final /*@NonInvalid*/ TestConfiguration testConfiguration = getParentTestDescription_0.getTestConfiguration();
			final /*@NonInvalid*/ List<ComponentInstance> componentInstance = testConfiguration.getComponentInstance();
			final /*@NonInvalid*/ SetValue BOXED_componentInstance = idResolver.createSetOfAll(tdlTables.SET_CLSSid_ComponentInstance, componentInstance);
			final /*@NonInvalid*/ OrderedSetValue asOrderedSet_0 = CollectionAsOrderedSetOperation.INSTANCE.evaluate(BOXED_componentInstance);
			local_0 = asOrderedSet_0;
		}
		final /*@NonInvalid*/ List<ComponentInstance> ECORE_local_0 = ((IdResolverExtension)idResolver).ecoreValueOfAll(ComponentInstance.class, local_0);
		return (EList<ComponentInstance>)ECORE_local_0;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
	{
		switch (featureID) {
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				return ((InternalEList<?>)getComponentInstanceBinding()).basicRemove(otherEnd, msgs);
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				return ((InternalEList<?>)getArgument()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType)
	{
		switch (featureID) {
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION:
				if (resolve) return getTestDescription();
				return basicGetTestDescription();
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				return getComponentInstanceBinding();
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				return getArgument();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue)
	{
		switch (featureID) {
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION:
				setTestDescription((TestDescription)newValue);
				return;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				getComponentInstanceBinding().clear();
				getComponentInstanceBinding().addAll((Collection<? extends ComponentInstanceBinding>)newValue);
				return;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				getArgument().clear();
				getArgument().addAll((Collection<? extends ParameterBinding>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID)
	{
		switch (featureID) {
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION:
				setTestDescription((TestDescription)null);
				return;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				getComponentInstanceBinding().clear();
				return;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				getArgument().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID)
	{
		switch (featureID) {
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__TEST_DESCRIPTION:
				return testDescription != null;
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__COMPONENT_INSTANCE_BINDING:
				return componentInstanceBinding != null && !componentInstanceBinding.isEmpty();
			case tdlPackage.TEST_DESCRIPTION_REFERENCE__ARGUMENT:
				return argument != null && !argument.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public int eDerivedOperationID(int baseOperationID, Class<?> baseClass)
	{
		if (baseClass == Behaviour.class) {
			switch (baseOperationID) {
				case tdlPackage.BEHAVIOUR___GET_PARTICIPATING_COMPONENTS: return tdlPackage.TEST_DESCRIPTION_REFERENCE___GET_PARTICIPATING_COMPONENTS;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		if (baseClass == AtomicBehaviour.class) {
			switch (baseOperationID) {
				case tdlPackage.ATOMIC_BEHAVIOUR___GET_PARTICIPATING_COMPONENTS: return tdlPackage.TEST_DESCRIPTION_REFERENCE___GET_PARTICIPATING_COMPONENTS;
				default: return super.eDerivedOperationID(baseOperationID, baseClass);
			}
		}
		return super.eDerivedOperationID(baseOperationID, baseClass);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException
	{
		switch (operationID) {
			case tdlPackage.TEST_DESCRIPTION_REFERENCE___GET_PARTICIPATING_COMPONENTS:
				return getParticipatingComponents();
		}
		return super.eInvoke(operationID, arguments);
	}

} //TestDescriptionReferenceImpl
